/******************************************************************************
*******************************************************************************

	Fuzed DS
	relminator
	http://rel.phatcode.net


*******************************************************************************
******************************************************************************/

#include "TextMaps.h"


namespace TextMap
{

std::vector<const char**> Maps;



void OptimizeMaps()
{
	
	Maps.push_back( TextMap1 );
	Maps.push_back( TextMap2 );
	Maps.push_back( TextMap3 );
	Maps.push_back( TextMap4 );
	Maps.push_back( TextMap5 );
	Maps.push_back( TextMap6 );
	Maps.push_back( TextMap7 );
	Maps.push_back( TextMap8 );
	Maps.push_back( TextMap9 );
	Maps.push_back( TextMap10 );
	Maps.push_back( TextMap11 );
	Maps.push_back( TextMap12 );
	Maps.push_back( TextMap13 );
	Maps.push_back( TextMap14 );
	Maps.push_back( TextMap15 );
	Maps.push_back( TextMap16 );
	
}


/*

	+ = Brick Normal
	# = Brick Grass 
	$ = Ladder 
	T = Top Ladder 
	t = Top Ladder handle

	H = Horizontal Spiral
	V = Vertical Spiral
	D = Diagonal Spiral
	R = Red Turtle
	G = Green Turtle
	B = Bouncer
	J = Jumper
	M = Magneto Right
	m = Magneto Left
	F = Fire
	
	0 = Brown Block 
		- Can be Pushed
		- Can fall
		- Can be destroyed by bombs
		- Can kill enemies
	9 = Red Block
	    - Can be Pushed
		- Can fall
		- Cannot be destroyed by bombs
		- Can kill enemies
		- Can be thrown
	7 = Green Block
	    - Cannot be Pushed
		- Cannot fall
		- Cannot be destroyed by bombs
		- Vanishes 1 second after you step on it
	* = Orange Block
	    - Cannot be Pushed
		- Cannot fall
		- Can be destroyed by bombs
		
	
	@ = Bomb up 
	& = Magic up
	S = Snipe
	
*/

const char *TextMap1[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+S    9    0    CS0+",		// 1	
	"+**R  *    9   C77 +",		// 1	
	"+  ^^^@ J  9  C7   +",		// 2	
	"+X ++++R 9097 7  R +",		// 3	
	"+++++++++++*  #~~~~+",		// 4	
	"+ H       m9  0###w+",		// 5	
	"+D      ? &9# 0S0+w+",		// 6	
	"+*   C  |~#~~~~~~~~+",		// 7	
	"+S#  7# !wwwwwwwwww+",		// 8	
	"+*++    ++++++++++++",		// 9	
	"+GSt#   ?S   R0  V +",		// 0	
	"+##T||####  0**++ S+",		// 1	
	"+  $//  *  **M m+##+",		// 2	
	"+B $H 0S+ * R#  9&<+",		// 3	
	"+##################+",		// 0
	"QQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap2[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+                  +",		// 2	
	"+                  +",		// 3	
	"+                  +",		// 4	
	"+                X +",		// 5	
	"+              S ##+",		// 6	
	"+            S 7   +",		// 7	
	"+          S 7     +",		// 8	
	"+        S 7       +",		// 9	
	"+      S 7         +",		// 0	
	"+    S 7           +",		// 1	
	"+>FS 7             +",		// 2	
	"++ 7FFFFFFFFFFFFFFF+",		// 3	
	"++++++++++++++++++++",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap3[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+                  +",		// 2	
	"+                  +",		// 3	
	"+                  +",		// 4	
	"+           X      +",		// 5	
	"+           ##     +",		// 6	
	"+     9       SC   +",		// 7	
	"+    ###########   +",		// 8	
	"+ S     9          +",		// 9	
	"+ #########        +",		// 0	
	"+      9     S     +",		// 1	
	"+S> ##########     +",		// 2	
	"+++                +",		// 3	
	"+^^^^^^^^^^^^^^^^^^+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap4[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+X> 0              +",		// 2	
	"+####              +",		// 3	
	"+     S   0        +",		// 4	
	"+    ######        +",		// 5	
	"+            CS 0  +",		// 6	
	"+         #######  +",		// 7	
	"+     S0 C         +",		// 8	
	"+    #####         +",		// 9	
	"+          C0 SS   +",		// 0	
	"+         #########+",		// 1	
	"+                  +",		// 2	
	"+                  +",		// 3	
	"++++++++++++++++++++",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};


const char *TextMap5[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+C S     9 S     < +",		// 1	
	"+######  ###  #####+",		// 2	
	"+                  +",		// 3	
	"+                  +",		// 4	
	"+ H C      @   X   +",		// 5	
	"+**00**************+",		// 6	
	"+  00              +",		// 7	
	"+  00              +",		// 8	
	"+ ++++C            +",		// 9	
	"++++++++^^^^+  S  C+",		// 0	
	"+################ #+",		// 1	
	"+                  +",		// 2	
	"+^^^^^^^^^^^^^^^^^^^",		// 3	
	"++++++++++++++++++++",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap6[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+                  +",		// 2	
	"+                  +",		// 3	
	"+  @S9 G 00 @  9 B +",		// 4	
	"+********00********+",		// 5	
	"++   +   00     C  +",		// 6	
	"++S  + @ 00@ 9  # <+",		// 7	
	"++++++00********* *+",		// 8	
	"+     00        C  +",		// 9	
	"+     00S      M V +",		// 0	
	"+#########    ### #+",		// 1	
	"+                  +",		// 2	
	"+^^^^^^^^^^^^^ X   +",		// 3	
	"+++++++++++++++++^^+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap7[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+   J            < +",		// 1	
	"+*********S********+",		// 2	
	"+ ++++++++9+++++++++",		// 3	
	"+    C    9 C      +",		// 4	
	"+    0  **********S+",		// 5	
	"+  # *###S********++",		// 6	
	"+@#t   &##+ *******+",		// 7	
	"+++T+*****+C*******+",		// 8	
	"+ C$      ++++++++ +",		// 9	
	"+S $   t  + M  S  *+",		// 0	
	"+######T##+ #~~~~~~+",		// 1	
	"+      $  +  #wwwww+",		// 2	
	"+S @ M $ B+X  #wwww+",		// 3	
	"+##################+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap8[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+                  +",		// 2	
	"+          <       +",		// 3	
	"+ S     #####    S +",		// 4	
	"+ #####       #### +",		// 5	
	"+       R      C   +",		// 6	
	"+S C  ########### S+",		// 7	
	"+####          S  7+",		// 8	
	"+      #######C7   +",		// 9	
	"+    7        7    +",		// 0	
	"+ S          R   X +",		// 1	
	"+ #####  7  #### ##+",		// 2	
	"+                  +",		// 3	
	"+^^^^^^^^^^^^^^^^^^+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap9[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+ >                +",		// 2	
	"+####              +",		// 3	
	"+      S  C        +",		// 4	
	"+      ####      S +",		// 5	
	"+  S0           ###+",		// 6	
	"+  ####   0  S     +",		// 7	
	"+       #######    +",		// 8	
	"+    S0            +",		// 9	
	"+    ##            +",		// 0	
	"+S      C  9S    X +",		// 1	
	"+###   ######    ##+",		// 2	
	"+                  +",		// 3	
	"+^^^^^^^^^^^^^^^^^^+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap10[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +",     // 1	
	"+   9777     X   RS+",		// 1	
	"+S 7*    777 +++++++",		// 2	
	"+7                 +",		// 3	
	"++7+++ + CC  0     +",		// 4	
	"+ S9   +++++00     +",		// 5	
	"+ ++        0*   F +",		// 6	
	"+ +     9   *    t +",		// 7	
	"+ +G    90 *  G##T#+",		// 8	
	"+ +^^^^^00    *  $ +",		// 9	
	"+##########  *   $ +",		// 0	
	"+ C         *C C $ +",		// 1	
	"+#*#       *  J  $ +",		// 2	
	"+&  9 @  < +SFFFF$F+",		// 3	
	"++++++++++++++++++++",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap11[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+        >         +",		// 1	
	"+**  **********  **+",		// 2	
	"+*****  ****  *****+",		// 3	
	"+**CS**********SC**+",		// 4	
	"+*****  CSSC  *****+",		// 5	
	"+*S**************S*+",		// 6	
	"+****CSS****SSC****+",		// 7	
	"+*S ************ S*+",		// 8	
	"+ *** FFFFFFFF *** +",		// 9	
	"+** C**********C **+",		// 0	
	"+****  S****S  ****+",		// 1	
	"+**S ********** S**+",		// 2	
	"+*****        *****+",		// 3	
	"+S   *B  X   J*  S*+",		// 0
	"++++++++++++++++++++",
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap12[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+                  +",		// 2	
	"+                  +",		// 3	
	"+    @@ 9C9C9      +",		// 4	
	"+   +++*******     +",		// 5	
	"+C  9              +",		// 6	
	"+++***  < 9@C9@C9  +",		// 7	
	"+       ++++****** +",		// 8	
	"+      *           +",		// 9	
	"+S   C*   CS       +",		// 0	
	"++   +    ++       +",		// 1	
	"+                  +",		// 2	
	"+                X +",		// 3	
	"+^^^^^^^^^^^^^^^^+++",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap13[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+                CS+",		// 2	
	"+       *>*     C##+",		// 3	
	"+      * *  7 7 #  +",		// 4	
	"+     * * *        +",		// 5	
	"+   S* * *         +",		// 6	
	"+   * * *          +",		// 7	
	"+@ * * *           +",		// 8	
	"+** *S*            +",		// 9	
	"+ S* *       0     +",		// 0	
	"+++**        9SSC9C+",		// 1	
	"++  ++S    + #*****+",		// 2	
	"++X +++            +",		// 3	
	"+++++++^^^^^++++^^^+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap14[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+                  +",		// 2	
	"+                  +",		// 3	
	"+ > 0              +",		// 4	
	"+ ++++     M 0     +",		// 5	
	"+  R    m ++++    S+",		// 6	
	"+++++++ +     C ++++",		// 7	
	"+             ++   +",		// 8	
	"+        M       CS+",		// 9	
	"+X       +       +++",		// 0	
	"++++++ F    +++ 7  +",		// 1	
	"+      C       7   +",		// 2	
	"+FFFFFF+FFFFFFFFFFF+",		// 3	
	"++++++++++++++++++++",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap15[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+ 9  C  ****   mM  +", // 1	
	"+>   9  +@S+C  ++  +",		// 1	
	"+++FF7FF++++      C+",		// 2	
	"++++++++++++++++++*+",		// 3	
	"+++9      M m ++*  +",		// 4	
	"+ 9**FFFFFFFX +@ 9 +",		// 5	
	"+ *t+++++++++++****+",		// 6	
	"+++T+@  9          +",		// 7	
	"+  $ +    @********+",		// 8	
	"+  $  *****        +",		// 9	
	"+S $&              +",		// 0	
	"++++++             +",		// 1	
	"+        ++   FS   +",		// 2	
	"+     +       ++++ +",		// 3	
	"+^^^^^^^^^^^^^^^^^^+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

const char *TextMap16[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+       >          +", // 1	
	"+ 0@9&0 9   @9&C@9@+",		// 1	
	"+++***++*CC+***+++++",		// 2	
	"+     CS M S  C    +",		// 3	
	"+& S  ++++++       +",		// 4	
	"++++           R X +",		// 5	
	"++            ++++++",		// 6	
	"++ R CCCCC         +",		// 7	
	"++########  C R  S +",		// 8	
	"++         ########+",		// 9	
	"++                 +",		// 0	
	"++                 +",		// 1	
	"++                 +",		// 2	
	"++                 +",		// 3	
	"+^^^^^^^^^^^^^^^^^^+",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};


const char *TextMap17[] =
{  //			1		  2		    3         4        5 

   //012345678901234567890123456789012345678901234567890
	"++++++++++++++++++++",		// 0
	"+                  +", // 1	
	"+                  +",		// 1	
	"+ >@&              +",		// 2	
	"+####              +",		// 3	
	"+       9F         +",		// 4	
	"+      ####        +",		// 5	
	"+   X           ###+",		// 6	
	"+  ####            +",		// 7	
	"+       #######    +",		// 8	
	"+                  +",		// 9	
	"+    ##            +",		// 0	
	"+                  +",		// 1	
	"+###   ######    ##+",		// 2	
	"+                  +",		// 3	
	"++++++++++++++++++++",		// 0
	"QQQQQQQQQQQQQQQQQQQQ"		// Terminator

};

}    // end namespace